%if 0%{?fedora} == 16
%define _unitdir /lib/systemd/system
%endif

Name:		daemontools
Version:	0.76
Release:	3%{?dist}
Summary:	DJB daemontools

Group:		System Environment/Daemons
License:	GPLv2
URL:		http://cr.yp.to/daemontools.html
Source0:	http://cr.yp.to/daemontools/%{name}-%{version}.tar.gz
Source1:	%{name}-%{version}-man.tar.bz2
Source2:	svscanboot.service
Patch0:		%{name}-%{version}.errno.patch

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

%if 0%{?fedora} >= 16
Requires(post):	systemd-units
Requires(preun): systemd-units
%endif


%description
Supervise monitors a service. It starts the service and restarts the
service if it dies.  The companion  svc program  stops,  pauses,  or
restarts the service on sysadmin request.  The svstat program prints
a one-line status report.

Multilog saves error  messages to  one or more  logs.  It optionally
timestamps each line and,  for each log,  includes or excludes lines
matching specified patterns.  It automatically rotates logs to limit
the amount of disk space used.   If the disk fills up, it pauses and
tries again, without losing any data.

%prep
%setup -q -n admin/%{name}-%{version}
%patch0 -p1
%setup -q -T -D -c -a 1 -n admin/%{name}-%{version}

%build
echo "gcc %{optflags}" > src/conf-cc
echo "gcc -s %{optflags}" > src/conf-ld
echo "%{_prefix}" > src/conf-home
package/compile

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man8
mkdir -p %{buildroot}/command
mkdir -p %{buildroot}/service/clear

install -m 755 command/* %{buildroot}%{_bindir}
install -m 644 %{name}-%{version}-man/*.8 %{buildroot}%{_mandir}/man8

touch %{buildroot}/service/clear/down
%{__cat} <<EOF > %{buildroot}/service/clear/run
#!/bin/sh
yes '' | head -4000 | tr '\n' .

# When you want to clear the service errors, just run this:
# svc -o /service/clear
EOF
chmod +x %{buildroot}/service/clear/run

for i in `cat package/commands`
do
	ln -s ..%{_bindir}/$i %{buildroot}/command/$i
done

%if 0%{?fedora} >= 16
install -D -m0644 %{SOURCE2} %{buildroot}%{_unitdir}/svscanboot.service
%endif

%post
%if 0%{?fedora} >= 16
	%systemd_post svscanboot.service
%endif
%if 0%{?rhel} || 0%{?fedora} < 16
install -d -m0755 %{buildroot}%{_sysconfdir}
echo "SV:123456:respawn:/command/svscanboot" >> %{buildroot}%{_sysconfdir}/inittab
/sbin/init q
%endif

%preun
%if 0%{?fedora} >= 16
if [ "$1" = 0 ]; then
	%systemd_preun svscanboot.service
fi
%endif
%if 0%{?rhel} || 0%{?fedora} < 16
sed -i 's,SV:123456:respawn:/command/svscanboot,,g' %{_sysconfdir}/inittab
/sbin/init q
%endif

%files
%doc src/CHANGES package/README src/TODO
%attr(0755,root,root) %{_bindir}/svscan
%attr(0755,root,root) %{_bindir}/svscanboot
%attr(0755,root,root) %{_bindir}/supervise
%attr(0755,root,root) %{_bindir}/svc
%attr(0755,root,root) %{_bindir}/svok
%attr(0755,root,root) %{_bindir}/svstat
%attr(0755,root,root) %{_bindir}/fghack
%attr(0755,root,root) %{_bindir}/multilog
%attr(0755,root,root) %{_bindir}/pgrphack
%attr(0755,root,root) %{_bindir}/tai64n
%attr(0755,root,root) %{_bindir}/tai64nlocal
%attr(0755,root,root) %{_bindir}/readproctitle
%attr(0755,root,root) %{_bindir}/softlimit
%attr(0755,root,root) %{_bindir}/envuidgid
%attr(0755,root,root) %{_bindir}/envdir
%attr(0755,root,root) %{_bindir}/setlock
%attr(0755,root,root) %{_bindir}/setuidgid
%attr(0755,root,root) %dir /command
%attr(0755,root,root) /command/*
%attr(0755,root,root) %dir /service
%attr(0755,root,root) /service/clear/run
%attr(0444,root,root) /service/clear/down
%attr(0644,root,root) %{_mandir}/man8/*.8*
%if 0%{?fedora} >= 16
%attr(0644,root,root) %{_unitdir}/svscanboot.service
%endif

%changelog
* Wed Feb 20 2013 momo-i <webmaster@momo-i.org> 0.76-1
- Initial rpm release.
